#include<R.h>
#include<Rmath.h>
#include<R_ext/Applic.h>

void mycchol(double *v, int *p, double *L) {
  int info=0;
  F77_NAME(chol)(v, p, p, L, &info);
}

void myrmvnorm(int *n, double *m, double *v, 
	       int *p, double *res) {
  int i,j,k, np=*n*(*p), pp=*p*(*p), info=0, idaux, idam;
  double lchol[pp], z[*p], aux[*p];

  for (i=0;i<pp;i++) lchol[i]=0;
  for (i=0;i<*p;i++) z[i]=0;
  for (i=0;i<*p;i++) aux[i]=0;

  F77_NAME(chol)(v, p, p, lchol, &info);

  GetRNGstate();
  for (k=0; k<*n; k++) {
    idam = k*(*p);
    for (j=0; j<*p; j++)
      z[j] = rnorm(0,1);
    aux[0] = z[0]*lchol[0];
    for (j=1; j<*p; j++) {
      idaux = j*(*p);
      aux[j] = z[0]*lchol[idaux];
      for (i=1; i<=j; i++)
        aux[j] += z[i]*lchol[idaux+i];
    }
    for (j=0; j<*p; j++)
      res[idam+j] = m[j] + aux[j];
  }
  PutRNGstate();
}








